'\" t
.\"     Title: git-export-filter
.\"    Author: [see the "AUTHOR" section]
.\" Generator: DocBook XSL Stylesheets v1.75.2 <http://docbook.sf.net/>
.\"    Manual: Git Manual
.\"  Language: English
.\"
.TH "GIT\-EXPORT\-FILTER" "1" "" "Git" "Git Manual"
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "NAME"
git-export-filter \- Filter fast\-export data with optional rewrites
.SH "SYNOPSIS"
.sp
.nf
\fIgit export\-filter\fR [\-\-verbose|\-v] [\-h|\-\-help] [\-\-version|\-V] [\-\-debug|\-d]
                  [\-\-authors\-file=<authors_file> [\-\-require\-authors]]
                  [\-\-branches\-file=<branches_file>] [\-\-trunk\-is\-master]
                  [\-\-convert\-tagger=<email>] [\-\-strip\-at\-suffix]
                  [\-\-expand\-renames] [\-\-names] [\-\-]
                  [<input_file>] > <output_file>
.fi
.sp
.SH "DESCRIPTION"
.sp
Filters a git fast\-export data stream optionally rewriting author and/or branch names along the way and writes the result to standard output\&.
.sp
When given no options or arguments, simply copies the input to the output\&. In this case the input is still parsed and invalid fast\-export input data will still be detected even though no rewriting is being performed\&.
.SH "OPTIONS"
.PP
\-\-verbose, \-\-v
.RS 4
Show additional information on standard error while processing the data stream\&.
.RE
.PP
\-\-help, \-h
.RS 4
Show basic help\&. If
\-\-verbose
is given first show extensive help\&. No conversion is performed if this option is given\&.
.RE
.PP
\-\-version, \-\-V
.RS 4
Show the version information\&. No conversion is performed if this option is given\&.
.RE
.PP
\-\-debug, \-d
.RS 4
Show debugging information on standard error during the conversion\&.
.RE
.PP
\-\-authors\-file <authors_file>
.RS 4
Specifies author/committer names to rewrite\&. See the "REWRITE FILE FORMAT" below for information on
<authors_file>
format\&.
.RE
.PP
\-\-require\-authors
.RS 4
May only be specified if
\-\-authors\-file
is also specified\&. If this option is given, then all author/committer names encountered in the input stream must be found in
<authors_file>
or an error will occur and the conversion will stop\&. If this option is not given then author/committer names not listed in
<authors_file>
are left unchanged\&.
.RE
.PP
\-\-branches\-file <branches_file>
.RS 4
Specifies branch and/or tag names to rewrite\&. See the "REWRITE FILE FORMAT" below for information on
<branches_file>
format\&.
.sp
Annotated tag names can be renamed but only if they are located under
refs/tags/
as the fast\-export file format forces that prefix to be present\&. The
refs/tags/
prefix must be included in the
<branches_file>
on both the left and right sides of the
=
in order to successfully rewrite annotated tag names\&.
.RE
.PP
\-\-trunk\-is\-master
.RS 4
Giving this option converts
refs/heads/trunk
to
refs/heads/master
in the output\&. The
\-\-trunk\-is\-master
option can be given in place of or in addition to the
\-\-branches\-file
option\&.
.sp
Really this is just intended to be a shortcut to having a
<branches_file>
with a single line
refs/heads/trunk=refs/heads/master
in it\&.
.RE
.PP
\-\-convert\-tagger <email>
.RS 4
If this option is given, then any annotated tags with a committer that has an email of
<email>
will be converted to a lightweight tag\&.
.sp
Some fast\-export producers create tag commands which always use a fixed tagger (typically
tagger) with a data length of 0 and a timestamp identical to the commit that is being tagged\&. In other words, a lightweight tag in disguise\&.
.sp
The
\-\-convert\-tagger
option can be used to convert these lightweight\-tag\-in\-disguise annotated tags to a real lightweight tags\&.
.RE
.PP
\-\-strip\-at\-suffix
.RS 4
If this option is given then when converting author/committer names, if the authors file does not contain an exact match for the email and the email contains an
\fI@\fR
sign then the email is looked up again after stripping everything starting with and including the
\fI@\fR
character from the end\&.
.sp
The
\fIsvn\-fe\fR
utility appends
\fI@\&...\fR
suffixes to the email addresses it generates in the fast\-export data and will need this option to use a standard
\fIgit svn\fR
authors file\&.
.RE
.PP
\-\-expand\-renames
.RS 4
Some importers of fast\-export data cannot handle renames but can handle copies\&. If \-\-expand\-renames is given then any instances of filerename
\fIR\fR
are replaced with a filecopy
\fIC\fR
followed by a filedelete
\fID\fR
instead\&.
.RE
.PP
\-\-names
.RS 4
This option may not be combined with any of the others\&. Instead of outputting a modified fast\-import stream, output only the author, committer and tagger names as they are encountered one per line without any timestamp information\&. This can be used to help build an initial authors file\&.
.sp
Do note that the names are output as\-is from the input stream whereas this utility expects to match only the email portion when given an authors file with the \-\-authors\-file option\&. This means the name, non\-email portion and surrounding
\fI<\fR
and
\fI>\fR
characters will have to be removed from the output provided by this option\&. Additionally, of course, duplicate names need to be removed as well\&.
.RE
.PP
<input_file>
.RS 4
The fast\-export stream to read\&. If
<input_file>
is omitted, then standard input will be read\&.
.RE
.SH "REWRITE FILE FORMAT"
.sp
Syntax is compatible with the \fIgit svn\fR \-\-authors\-file and \fIgit cvsimport\fR \-A files\&. For committer/author rewrites the syntax looks like:
.sp
.if n \{\
.RS 4
.\}
.nf
        email = John Smith <smith@example\&.com>
.fi
.if n \{\
.RE
.\}
.sp
.sp
And for branch rewrites it looks like:
.sp
.if n \{\
.RS 4
.\}
.nf
        refs/heads/ALL_CAPS = refs/heads/small_caps
.fi
.if n \{\
.RE
.\}
.sp
.sp
Blank lines and lines starting with # are ignored\&.
.sp
Note that when rewriting author/committer names, only the <email> portion (the part between < and >) of the name is matched, the rest of the name is ignored for matching purposes\&.
.SH "TIPS"
.sp
If the input data is the result of fossil export \-\-git then probably the \-\-trunk\-is\-master and \-\-convert\-tagger tagger options will be needed\&.
.SH "AUTHOR"
.sp
Kyle J\&. McKay <mackyle@gmail\&.com>
.SH "GIT"
.sp
Not part of the \fBgit\fR(1) suite yet
